Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(Revision 2398)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(Arbeitskopie)
@@ -37,7 +37,7 @@
 /***************************************************
  *  EDITOR INITIALIZATION AND CONFIGURATION
  ***************************************************/
- 
+
 /*
  * Set some basic paths
  */
@@ -639,7 +639,7 @@
 			newObj["labelUsed"] = true;
 		}
 		HTMLArea._addEvents(newObj["el"],["mouseover", "mouseout", "mousedown", "click"], HTMLArea.toolBarButtonHandler);
-		
+
 		if (typeof(btn[1]) != "string" && HTMLArea.is_ie) {
 			var btnImgContainer = document.createElement("div");
 			btnImgContainer.className = "buttonImgContainer";
@@ -735,7 +735,7 @@
 			}
 		}
 	}
-	
+
 	tb_line = HTMLArea.newLine(toolbar);
 	this._htmlArea.appendChild(toolbar);
 };
@@ -883,19 +883,17 @@
  * Size the iframe according to user's prefs or initial textarea
  */
 HTMLArea.prototype.sizeIframe = function(diff) {
-	var i;
 	var height = (this.config.height == "auto" ? (this._textArea.style.height) : this.config.height);
 	var textareaHeight = height;
+		// All nested tabs and inline levels in the sorting order they were applied:
+	this.nested = {};
+	this.nested.all = RTEarea[this._editorNumber].tceformsNested;
+	this.nested.sorted = HTMLArea.simplifyNested(this.nested.all);
+		// Clone the array instead of using a reference (this.accessParentElements will change the array):
+	var parentElements = (this.nested.sorted && this.nested.sorted.length ? [].concat(this.nested.sorted) : []);
+		// Walk through all nested tabs and inline levels to make a correct positioning:
+	var dimensions = this.accessParentElements(parentElements, 'this.getDimensions()');
 
-	var inlineObject = RTEarea[this._editorNumber].tceformsInlineObject;
-	var dynTabs = RTEarea[this._editorNumber].tceformsDynTabs;
-
-	var parentElements = new Array();
-	if (dynTabs) parentElements = dynTabs.split(',');
-	if (inlineObject) parentElements.push(inlineObject);
-
-	var dimensions = this.accessParentElements(parentElements, 'this.getDimensions()');
-			
 	if(height.indexOf("%") == -1) {
 		height = parseInt(height) - diff;		
 		if (this.config.sizeIncludesToolbar) {
@@ -938,7 +936,7 @@
 };
 
 /**
- * Access an inline relational element and make it "accesible".
+ * Access an inline relational element or tab menu and make it "accesible".
  * If a parent object has the style "display: none", offsetWidth & offsetHeight are '0'.
  *
  * @params	object		callbackFunc: A function to be called, when the embedded objects are "accessible".
@@ -947,12 +945,12 @@
  */
 HTMLArea.prototype.accessParentElements = function(parentElements, callbackFunc) {
 	var result = {};
-	
+
 	if (parentElements.length) {
 		var currentElement = parentElements.pop();
 		var elementStyle = document.getElementById(currentElement).style;
-		var actionRequired = elementStyle.display == 'none';
-		
+		var actionRequired = (elementStyle.display == 'none' ? true : false);
+
 		if (actionRequired) {
 			var originalVisibility = elementStyle.visibility;
 			var originalPosition = elementStyle.position;
@@ -960,23 +958,49 @@
 			elementStyle.position = 'absolute';
 			elementStyle.display = '';
 		}
-		
+
 		result = this.accessParentElements(parentElements, callbackFunc);
-		
+
 		if (actionRequired) {
 			elementStyle.display = 'none';
 			elementStyle.position = originalPosition;
 			elementStyle.visibility = originalVisibility;
 		}
-		
+
 	} else {
 		result = eval(callbackFunc);		
 
 	}
-	
+
 	return result;
 };
 
+/**
+ * Simplify the array of nested levels. Create an indexed array with the correct names of the elements.
+ *
+ * @param	object		nested: The array with the nested levels
+ * @return	object		The simplified array
+ * @author	Oliver Hader <oh@inpublica.de>
+ */
+HTMLArea.simplifyNested = function(nested) {
+	var i, type, level, max, simplifiedNested=[];
+	if (nested && nested.length) {
+		if (nested[0][0]=='inline') {
+			nested = inline.findContinuedNestedLevel(nested, nested[0][1]);
+		}
+		for (i=0, max=nested.length; i<max; i++) {
+			type = nested[i][0];
+			level = nested[i][1];
+			if (type=='tab') {
+				simplifiedNested.push(level+'-DIV');
+			} else if (type=='inline') {
+				simplifiedNested.push(level+'_fields');
+			}
+		}
+	}
+	return simplifiedNested;
+};
+
 /*
  * Initialize the iframe
  */
@@ -1065,9 +1089,9 @@
 HTMLArea.prototype.stylesLoaded = function() {
 	var doc = this._doc;
 	var docWellFormed = true;
-	
+
 		// check if the stylesheets have been loaded
-	
+
 	if (this._stylesLoadedTimer) window.clearTimeout(this._stylesLoadedTimer);
 	var stylesAreLoaded = true;
 	var errorText = '';
@@ -1083,7 +1107,7 @@
 		return false;
 	}
 	HTMLArea._appendToLog("[HTMLArea::initIframe]: Stylesheets successfully loaded.");
-	
+
 	if (!this.config.fullPage) {
 		doc.body.style.borderWidth = "0px";
 		doc.body.className = "htmlarea-content-body";
@@ -1111,20 +1135,23 @@
 		this.setMode("docnotwellformedmode");
 		HTMLArea._appendToLog("[HTMLArea::initIframe]: Design mode could not be set.");
 	}
-	
+
 		// set editor number in iframe and document for retrieval in event handlers
 	doc._editorNo = this._editorNumber;
 	if (HTMLArea.is_ie) doc.documentElement._editorNo = this._editorNumber;
-	
+
 		// intercept events for updating the toolbar & for keyboard handlers
 	HTMLArea._addEvents((HTMLArea.is_ie ? doc.body : doc), ["keydown","keypress","mousedown","mouseup","drag"], HTMLArea._editorEvent, true);
-	
+
 		// add unload handler
-	HTMLArea._addEvent((this._iframe.contentWindow ? this._iframe.contentWindow : this._iframe.contentDocument), "unload", HTMLArea.removeEditorEvents);
-	
+	if (!HTMLArea.hasUnloadHandler) {
+		HTMLArea.hasUnloadHandler = true;
+		HTMLArea._addEvent((this._iframe.contentWindow ? this._iframe.contentWindow : this._iframe.contentDocument), "unload", HTMLArea.removeEditorEvents);
+	}
+
 		// set cleanWordOnPaste and intercept paste, dragdrop and drop events for wordClean
 	if (this.config.cleanWordOnPaste) HTMLArea._addEvents((HTMLArea.is_ie ? doc.body : doc), ["paste","dragdrop","drop"], HTMLArea.cleanWordOnPaste, true);
-	
+
 	window.setTimeout("HTMLArea.generatePlugins(" + this._editorNumber + ");", 100);
 };
 
@@ -1188,10 +1215,10 @@
 			window.clearInterval(editor._timerUndo);
 			editor._undoQueue = null;
 				// release events
-			if (HTMLArea._eventCache && !HTMLArea.is_opera) HTMLArea._eventCache.flush();
 			if (HTMLArea.is_ie) HTMLArea._cleanup(editor);
 		}
 	}
+	if (HTMLArea._eventCache && !HTMLArea.is_opera) HTMLArea._eventCache.flush();
 };
 
 /*
@@ -1612,7 +1639,7 @@
 	for (i in this._toolbarObjects) {
 		var btn = this._toolbarObjects[i];
 		cmd = i;
-		
+
 			// Determine if the button should be enabled
 		inContext = true;
 		if (btn.context && !text) {
@@ -1645,7 +1672,7 @@
 		}
 		if (cmd == "CreateLink") btn.state("enabled", (!text || btn.text) && (inContext || selection));
 			else btn.state("enabled", (!text || btn.text) && inContext && (selection || !btn.selection));
-		
+
 		if (typeof(cmd) == "function") { continue; };
 			// look-it-up in the custom dropdown boxes
 		var dropdown = this.config.customSelects[cmd];
@@ -1735,7 +1762,7 @@
 		    default: break;
 		}
 	}
-	
+
 	if (this._customUndo) this._undoTakeSnapshot();
 	for (i in this.plugins) {
 		var plugin = this.plugins[i].instance;
@@ -2515,7 +2542,7 @@
 	if (ar.length == 0) {
 		if (!HTMLArea.is_opera) el.removeAttribute(HTMLArea.is_gecko ? "class" : "className");
 			else el.className = '';
-		
+
 	} else el.className = ar.join(" ");
 };
 
@@ -2779,7 +2806,7 @@
 				} catch (e) { }
 			}
 		}
-	
+
 	if(req) {
 		var content = '';
 		for (var i in data) {
@@ -2792,7 +2819,7 @@
 		} else {
 			var postUrl = _typo3_host_url + _editor_url + url;
 		}
-		
+
 		function callBack() {
 			if(req.readyState == 4) {
 				if (req.status == 200) {
@@ -2808,7 +2835,7 @@
 			HTMLArea._appendToLog("[HTMLArea::_postback]: Request: " + content);
 			req.send(content);
 		}
-		
+
 		req.open('POST', postUrl, true);
 		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
 		window.setTimeout(sendRequest, 500);
@@ -2829,12 +2856,12 @@
  * Open modal popup window
  */
 Dialog._open = function(url, action, init, width, height, _opener, editor, scrollbars) {
-	
+
 	if (typeof(Dialog._modal) == "object" && typeof(Dialog._modal.close) == "function") {
 		Dialog._modal.close();
 		Dialog._modal = null;
 	}
-	
+
 	var dlg = window.open(url, 'hadialog', "toolbar=no,location=no,directories=no,menubar=no,width=" + width + ",height=" + height + ",scrollbars=" + scrollbars + ",resizable=yes,modal=yes,dependent=yes,top=100,left=100");
 	var obj = new Object();
 	obj.dialogWindow = dlg;
@@ -2842,7 +2869,7 @@
 	Dialog._modal = dlg;
 	Dialog._arguments = null;
 	if (typeof(init) != "undefined") { Dialog._arguments = init; }
-	
+
 				// Capture focus events
 	function capwin(w) {
 		if (HTMLArea.is_gecko) { w.addEventListener("focus", function(ev) { Dialog._parentEvent(ev); }, false); }
@@ -2850,7 +2877,7 @@
 		for (var i=0;i < w.frames.length;i++) { capwin(w.frames[i]); }
 	}
 	capwin(window);
-	
+
 		// Close dialog window
 	function closeDialog() {
 		if (Dialog._dialog && Dialog._dialog.dialogWindow) {
@@ -2975,21 +3002,21 @@
 		} else {
 			var RTE = RTEarea[editorNumber];
 			var config = new HTMLArea.Config();
-			
+
 				// Get the toolbar config
 			config.toolbar = RTE["toolbar"];
-			
+
 				// create an editor for the textarea
 			RTE["editor"] = new HTMLArea(RTE["id"], config);
 			var editor = RTE["editor"];
-			
+
 				// Save the editornumber in the object
 			editor._typo3EditerNumber = editorNumber;
 			editor._editorNumber = editorNumber;
 			config = editor.config;
-			
+
 			config.buttons = RTE["buttons"];
-			
+
 			config.hideTableOperationsInToolbar = RTE["hideTableOperationsInToolbar"] ? RTE["hideTableOperationsInToolbar"] : false;
 			config.disableLayoutFieldsetInTableOperations = RTE["disableLayoutFieldsetInTableOperations"] ? RTE["disableLayoutFieldsetInTableOperations"] : false;
 			config.disableAlignmentFieldsetInTableOperations = RTE["disableAlignmentFieldsetInTableOperations"] ? RTE["disableAlignmentFieldsetInTableOperations"] : false;
@@ -2997,11 +3024,11 @@
 			config.disableBordersFieldsetInTableOperations = RTE["disableBordersFieldsetInTableOperations"] ? RTE["disableBordersFieldsetInTableOperations"] : false;
 			config.disableColorFieldsetInTableOperations = RTE["disableColorFieldsetInTableOperations"] ? RTE["disableColorFieldsetInTableOperations"] : false;
 			config.disablePCexamples = RTE["disablePCexamples"] ? RTE["disablePCexamples"] : false;
-			
+
 			for (var plugin in RTE["plugin"]) {
 				if(RTE["plugin"][plugin]) { editor.registerPlugin(plugin); }
 			}
-			
+
 			if(RTE["defaultPageStyle"]) config.defaultPageStyle = RTE["defaultPageStyle"];
 			if(RTE["pageStyle"]) config.pageStyle = RTE["pageStyle"];
 			if(RTE["fontname"]) config.FontName = RTE["fontname"];
@@ -3024,9 +3051,9 @@
 			config.htmlRemoveTags = RTE["htmlRemoveTags"] ? RTE["htmlRemoveTags"] : null;
 			config.htmlRemoveTagsAndContents = RTE["htmlRemoveTagsAndContents"] ? RTE["htmlRemoveTagsAndContents"] : null;
 			config.htmlRemoveComments = RTE["htmlRemoveComments"] ? true : false;
-			
+
 			editor.onGenerate = HTMLArea.onGenerateHandler(editorNumber);
-			
+
 			editor.generate();
 			return false;
 		} 
@@ -3035,3 +3062,12 @@
 		document.getElementById('editorWrap' + editorNumber).style.visibility = 'visible';
 	}
 };
+
+HTMLArea.allElementsAreDisplayed = function(elements) {
+	for (var i=0, length=elements.length; i < length; i++) {
+		if (document.getElementById(elements[i]).style.display == 'none') {
+			return false;
+		}
+	}
+	return true;
+};
\ Kein Zeilenvorschub am Ende der Datei
Index: typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php
===================================================================
--- typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php	(Revision 2398)
+++ typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php	(Arbeitskopie)
@@ -356,7 +356,7 @@
 
 		$this->TCEform = $pObj;
 		$inline =& $this->TCEform->inline;
-		
+
 		$LANG->includeLLFile('EXT:' . $this->ID . '/locallang.xml');
 		$this->client = $this->clientInfo();
 		$this->typoVersion = t3lib_div::int_from_ver(TYPO3_version);
@@ -525,7 +525,7 @@
 			$RTEHeight = $RTEHeight + ($pObj->docLarge ?  (isset($BE_USER->userTS['options.']['RTELargeHeightIncrement']) ? $BE_USER->userTS['options.']['RTELargeHeightIncrement'] : 0) : 0);
 			$editorWrapWidth = $RTEWidth . 'px';
 			$editorWrapHeight = $RTEHeight . 'px';
-			$this->RTEdivStyle = $this->RTEdivStyle ? $this->RTEdivStyle : 'position:relative; left:0px; top:0px; height:' . $RTEHeight . 'px; width:'.$RTEWidth.'px; border: 1px solid black; padding: 2px 0px 2px 2px;';
+			$this->RTEdivStyle = 'position:relative; left:0px; top:0px; height:' . $RTEHeight . 'px; width:'.$RTEWidth.'px; border: 1px solid black; padding: 2px 0px 2px 2px;';
 			$this->toolbar_level_size = $RTEWidth;
 
 			/* =======================================
@@ -907,11 +907,6 @@
 	function registerRTEinJS($number, $table='', $uid='', $field='') {
 		global $TSFE, $TYPO3_CONF_VARS;
 
-			// if this RTE is shown inline of an IRRE record, the JS functions need to know about that
-		if ($this->TCEform->inline->inlineNames['object']) {
-			$tceformsInlineObject = $this->TCEform->inline->inlineNames['object'].'['.$table.']['.$uid.']_fields';
-		}
-
 		$registerRTEinJSString = (!is_object($TSFE) ? '' : '
 			' . '/*<![CDATA[*/') . '
 			RTEarea['.$number.'] = new Object();
@@ -928,8 +923,7 @@
 			RTEarea['.$number.']["showTagFreeClasses"] = ' . (trim($this->thisConfig['showTagFreeClasses'])?'true':'false') . ';
 			RTEarea['.$number.']["useHTTPS"] = ' . ((trim(stristr($this->siteURL, 'https')) || $this->thisConfig['forceHTTPS'])?'true':'false') . ';
 			RTEarea['.$number.']["enableMozillaExtension"] = ' . (($this->client['BROWSER'] == 'gecko' && $TYPO3_CONF_VARS['EXTCONF'][$this->ID]['enableMozillaExtension'])?'true':'false') . ';
-			RTEarea['.$number.']["tceformsInlineObject"] = "' . $tceformsInlineObject . '";
-			RTEarea['.$number.']["tceformsDynTabs"] = "' . (is_object($this->TCEform) && method_exists($this->TCEform, 'getDynTabLevelState') ? $this->TCEform->getDynTabLevelState('-DIV') : '') . '";';
+			RTEarea['.$number.']["tceformsNested"] = ' . (is_object($this->TCEform) && method_exists($this->TCEform, 'getDynNestedStack') ? $this->TCEform->getDynNestedStack(true) : '[]') . ';';
 
 			// The following properties apply only to the backend
 		if (!is_object($TSFE)) {
@@ -940,11 +934,10 @@
 			RTEarea['.$number.']["enablePersonalDicts"] = ' . ($this->spellCheckerPersonalDicts ? 'true' : 'false') . ';
 			RTEarea['.$number.']["userUid"] = "' . $this->userUid . '";';
 		}
-		
 			// Setting the plugin flags
 		$registerRTEinJSString .= '
 			RTEarea['.$number.']["plugin"] = new Object();';
-		
+
 		$pluginArray = t3lib_div::trimExplode(',', $this->pluginList , 1);
 		reset($pluginArray);
 		while( list(,$plugin) = each($pluginArray) ) {
